---------------------------
-- Appendix to Lemma 6.1
---------------------------

-- computations are done by Normaliz
loadPackage "Normaliz"

setNmzOption ("allf", true)

-- cone of exceptionally supported 1-cycles on P^3_{2,2}
Exc1 = matrix {{0,  1,  0,  0,  0},
               {0,  0,  1,  0,  0},
               {0,  0,  0,  1,  0},
               {0,  0,  0,  0,  1}}

-- linear cone of 2-cycles on P^3_{2,2}
Lin2 = matrix {{0,  1,  0,  0,  0},
               {0,  0,  1,  0,  0},
               {0,  0,  0,  1,  0},
               {0,  0,  0,  0,  1},
               {1,  0,  0, -1, -1},
               {1, -1,  0, -1,  0},
               {1, -1,  0,  0, -1},
               {1,  0, -1, -1,  0},
               {1,  0, -1,  0, -1}}

-- intersection table (dim 2 x dim 1)
M21 = matrix {{1,  0,  0,  0,  0},
              {0, -1,  0,  0,  0},
              {0,  0, -1,  0,  0},
              {0,  0,  0, -1,  0},
              {0,  0,  0,  0, -1}}

---------------------------------------------------
-- compute and print the dual of the linear cone
---------------------------------------------------
N = (normaliz (allComputations => true, Lin2*M21, "inequalities"))#"ext"

print N

-- reduced form (uncomment if needed)
-- R = (normaliz (allComputations => true, N || Exc1, "normalization"))#"ext"
--
-- print matrix sort toList (set entries R - set entries Exc1)
