---------------------------
-- Appendix to Lemma 6.3
---------------------------

-- computations are done by Normaliz
loadPackage "Normaliz"

setNmzOption ("allf", true)

-- cone of exceptionally supported 2-cycles on P^4_{3,2}
Exc2 = matrix {{0,  1,  0,  0,  0,  0,  0,  0},
               {0,  1,  0,  1,  0,  0,  0,  0},
               {0,  0,  1,  0,  0,  0,  0,  0},
               {0,  0,  1,  0,  1,  0,  0,  0},
               {0,  0,  0,  0,  0,  1,  0,  0},
               {0,  0,  0,  0,  0,  0,  1,  0},
               {0,  0,  0,  0,  0,  0,  0,  1}}

-- linear cone of 2-cycles on P^4_{3,2}
Lin2 = Exc2 || matrix {{1,  0,  0,  0,  0, -1, -1, -1},
                       {1, -1, -1,  0,  0, -1, -1,  0},
                       {1, -1, -1,  0,  0, -1,  0, -1},
                       {1, -1, -1,  0,  0,  0, -1, -1},
                       {1, -1, -2,  0, -1,  0,  0,  0},
                       {1,  0, -2,  0, -1, -1,  0,  0},
                       {1,  0, -2,  0, -1,  0, -1,  0},
                       {1,  0, -2,  0, -1,  0,  0, -1},
                       {1, -2, -1, -1,  0,  0,  0,  0},
                       {1, -2,  0, -1,  0, -1,  0,  0},
                       {1, -2,  0, -1,  0,  0, -1,  0},
                       {1, -2,  0, -1,  0,  0,  0, -1}}

-- intersection table (dim 2 x dim 1)
M22 = matrix {{1,  0,  0,  0,  0,  0,  0,  0},
              {0,  0,  0, -1,  0,  0,  0,  0},
              {0,  0,  0,  0, -1,  0,  0,  0}, 
              {0, -1,  0,  3,  0,  0,  0,  0},
              {0,  0, -1,  0,  3,  0,  0,  0},
              {0,  0,  0,  0,  0, -1,  0,  0},
              {0,  0,  0,  0,  0,  0, -1,  0},
              {0,  0,  0,  0,  0,  0,  0, -1}}

---------------------------------------------------
-- compute and print the dual of the linear cone
---------------------------------------------------
N = (normaliz (allComputations => true, Lin2*M22, "inequalities"))#"ext"

print N

-- reduced form (uncomment if needed)
-- R = (normaliz (allComputations => true, N || Exc2, "normalization"))#"ext"
--
-- print matrix sort toList (set entries R - set entries Exc2)
