-----------------------------
-- Appendix to Theorem 4.1
-----------------------------

-- computations are done by Normaliz
loadPackage "Normaliz"

setNmzOption ("allf", true)

-- cone of exceptionally supported 3-cycles on P^5_{0,5}
Exc3 = matrix {{0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0},
               {0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0},
               {0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0},
               {0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0},
               {0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0},
               {0,  1,  0,  0,  0,  0,  1,  0,  0,  0,  0},
               {0,  0,  1,  0,  0,  0,  0,  1,  0,  0,  0},
               {0,  0,  0,  1,  0,  0,  0,  0,  1,  0,  0},
               {0,  0,  0,  0,  1,  0,  0,  0,  0,  1,  0},
               {0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  1}}

-- linear cone of 3-cycles on P^5_{0,5}
Lin3 = matrix {{0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0},
               {0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0},
               {0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0},
               {0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0},
               {0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0},
               {0,  2,  0,  0,  0,  0,  1,  0,  0,  0,  0},
               {0,  0,  2,  0,  0,  0,  0,  1,  0,  0,  0},
               {0,  0,  0,  2,  0,  0,  0,  0,  1,  0,  0},
               {0,  0,  0,  0,  2,  0,  0,  0,  0,  1,  0},
               {0,  0,  0,  0,  0,  2,  0,  0,  0,  0,  1},
               {1, -3, -1,  0,  0,  0, -1,  0,  0,  0,  0},
               {1, -1, -3,  0,  0,  0,  0, -1,  0,  0,  0},
               {1,  0, -1, -3,  0,  0,  0,  0, -1,  0,  0},
               {1, -1,  0, -3,  0,  0,  0,  0, -1,  0,  0},
               {1,  0, -3, -1,  0,  0,  0, -1,  0,  0,  0},
               {1, -3,  0, -1,  0,  0, -1,  0,  0,  0,  0},
               {1,  0,  0, -1, -3,  0,  0,  0,  0, -1,  0},
               {1,  0, -1,  0, -3,  0,  0,  0,  0, -1,  0},
               {1, -1,  0,  0, -3,  0,  0,  0,  0, -1,  0},
               {1,  0, -3,  0, -1,  0,  0, -1,  0,  0,  0},
               {1, -3,  0,  0, -1,  0, -1,  0,  0,  0,  0},
               {1,  0,  0, -3, -1,  0,  0,  0, -1,  0,  0},
               {1,  0,  0,  0, -1, -3,  0,  0,  0,  0, -1},
               {1,  0,  0, -1,  0, -3,  0,  0,  0,  0, -1},
               {1,  0, -1,  0,  0, -3,  0,  0,  0,  0, -1},
               {1, -1,  0,  0,  0, -3,  0,  0,  0,  0, -1},
               {1,  0, -3,  0,  0, -1,  0, -1,  0,  0,  0},
               {1, -3,  0,  0,  0, -1, -1,  0,  0,  0,  0},
               {1,  0,  0, -3,  0, -1,  0,  0, -1,  0,  0},
               {1,  0,  0,  0, -3, -1,  0,  0,  0, -1,  0},
               {1, -1, -1, -1, -1,  0,  0,  0,  0,  0,  0},
               {1,  0, -1, -1, -1, -1,  0,  0,  0,  0,  0},
               {1, -1,  0, -1, -1, -1,  0,  0,  0,  0,  0},
               {1, -1, -1,  0, -1, -1,  0,  0,  0,  0,  0},
               {1, -1, -1, -1,  0, -1,  0,  0,  0,  0,  0}}

-- intersection table (dim 3 x dim 2)
M32 = matrix {{1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0},
              {0,  0,  0,  0,  0,  0, -1,  0,  0,  0,  0},
              {0,  0,  0,  0,  0,  0,  0, -1,  0,  0,  0},
              {0,  0,  0,  0,  0,  0,  0,  0, -1,  0,  0},
              {0,  0,  0,  0,  0,  0,  0,  0,  0, -1,  0},
              {0,  0,  0,  0,  0,  0,  0,  0,  0,  0, -1},
              {0, -1,  0,  0,  0,  0,  4,  0,  0,  0,  0},
              {0,  0, -1,  0,  0,  0,  0,  4,  0,  0,  0},
              {0,  0,  0, -1,  0,  0,  0,  0,  4,  0,  0},
              {0,  0,  0,  0, -1,  0,  0,  0,  0,  4,  0},
              {0,  0,  0,  0,  0, -1,  0,  0,  0,  0,  4}}

---------------------------------------------------
-- compute and print the dual of the linear cone
---------------------------------------------------
N = (normaliz (allComputations => true, Lin3*M32, "inequalities"))#"ext"

print N

-- reduced form (uncomment if needed)
-- R = (normaliz (allComputations => true, N || Exc3, "normalization"))#"ext"
--
-- print matrix sort toList (set entries R - set entries Exc3)
